;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function krSpincreateStepButton,imSize,left=left, right=right, $
         up=up, down=down

if keyword_set(left) then begin
  x = [imSize/3,2*imSize/3,2*imSize/3]
  y = [imSize/2,imSize/4,3*imSize/4]
endif else if keyword_set(right) then begin
  x = [imSize/3,2*imSize/3,imSize/3]
  y = [imSize/4,imSize/2,3*imSize/4]
endif else if keyword_set(up) then begin
  x = [imSize/4,3*imSize/4,imSize/2]
  y = [imSize/3,imSize/3,2*imSize/3]
endif else if keyword_set(down) then begin
  x = [imSize/4,imSize/2,3*imSize/4]
  y = [2*imSize/3,imSize/3,2*imSize/3]
endif

image = bytarr(imSize,imSize) + 192B
indices = polyfillv(x,y,imSize,imSize)
image[indices] = 0B
return,image
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSpinButtonEvent,event

;print,'regular event'
;help,event,/str
if event.id eq 0L then return ;catches stray timers

widget_control,event.id,get_uvalue=statePtr
state = *statePtr
if state.event_pro ne '' then begin
  widget_control,state.textId,get_value=value
  case event.id of
    state.upButtonId : begin
                      if event.press eq 1 then begin
                         direction = 'UP'
                         value = value + state.delta
                         widget_control, state.base,timer=.5
                         (*statePtr).currentButton = state.upButtonId
                         press = 1
                       endif else if event.release eq 1 then begin
                         (*statePtr).currentButton = 0L
                         press = 0
                       endif else return ;catches stay events on the mac
                       end
    state.downButtonId : begin
                       if event.press eq 1 then begin
                         direction = 'DOWN'
                         value = value - state.delta
                         widget_control, state.base,timer=.5
                         (*statePtr).currentButton = state.downButtonId
                         press = 1
                       endif else if event.release eq 1 then begin
                         (*statePtr).currentButton = 0L
                         press = 0
                       endif  else return ;catches stay events on the mac
                       end
    state.textId : begin
                   direction=''
                   press = 1
                   end
    else: begin
          direction = ''
          press = 0
          end
  endcase
  if press eq 1 then begin
    strVal = strcompress(string(value[0],format=state.format))
    widget_control,state.textId,set_value=strVal
    call_procedure,state.event_pro, $
        {top:event.top,handler:event.handler,id:state.base,direction:direction, $
         value:value[0]}
  endif
endif

return
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function krSpinButtonGet,base

childId = widget_info(base,/child)
widget_control, childId, get_uvalue=statePtr
widget_control, (*statePtr).textId, get_value=value

;value is a 1D array
return,value[0]
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSpinButtonTimer,event

;print,' timer event'
;help,event,/str
childId = widget_info(event.id,/child)
widget_control, childId, get_uvalue=statePtr
newEvent = {top:event.top,handler:event.handler,$
            id:(*statePtr).currentButton, press:1, release:0}
krSpinButtonEvent,newEvent

return
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSpinButtonDying,childId

widget_control, childId, get_uvalue=statePtr
if ptr_valid(statePtr) then ptr_free,statePtr

return
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function krSpinButton, parentBase, minimum=minimum, maximum=maximum, value=value, $
              drag=drag, event_pro=event_pro,  xsize=xsize, delta=delta, $
              ysize=ysize, title=title, format=format, uname=uname

if n_elements(parentBase) eq 0 then begin
  message,'A parent base is required'
  return,0
endif

if not keyword_set(minimum) then minimum = 0
if not keyword_set(maximum) then maximum = 100
if not keyword_set(value) then value = 50
if not keyword_set(event_pro) then event_pro=''
if not keyword_set(delta) then delta = 10
if not keyword_set(format) then format=''

strVal = strcompress(string(value,format=format))

base = widget_base(parentBase, xsize=xsize, ysize=ysize, row=1,/base_align_center, $
                   uname=uname, func_get_value='krSpinButtonGet',$
                   event_pro='krSpinButtonTimer',ypad=0,space=0)

if keyword_set(title) then void = widget_label(base,value=title,kill_notify='krSpinButtonDying')
textId = widget_text(base,value=strVal,ysize=1,xsize=strlen(strVal),/edit, $
                   event_pro='krSpinButtonEvent')
spinBase = widget_base(base,ypad=0,space=0,column=1)
stepSize = 15
;upButtonId = widget_button(spinBase, value=CVTTOBM(krSpincreateStepButton(stepSize,/up)),xsize=stepSize,ysize=stepSize, $
;                     event_pro='krSpinButtonEvent')
upButtonId = krbutton(spinBase, value=krSpincreateStepButton(stepSize,/up),xsize=stepSize,ysize=stepSize, $
                     event_pro='krSpinButtonEvent')

downButtonId = krbutton(spinBase, value=krSpincreateStepButton(stepSize,/down),xsize=stepSize,ysize=stepSize, $
                     event_pro='krSpinButtonEvent')

state = {parentBase:parentBase, base:base, event_pro:event_pro, upButtonId:upButtonId, $
         downButtonId:downButtonId, textId:textId, delta:delta, format:format, $
         currentButton:0L }
statePtr = ptr_new(state)
widget_control, upButtonId, set_uvalue=statePtr
widget_control, downButtonId, set_uvalue=statePtr
widget_control, textId, set_uvalue=statePtr
widget_control, widget_info(Base, /child), set_uvalue=statePtr
return, base
end